package com.huimv.video.dhicc.controller.ClientController;


import com.alibaba.fastjson.JSON;
import com.dahuatech.hutool.http.Method;
import com.dahuatech.icc.exception.ClientException;
import com.dahuatech.icc.oauth.http.DefaultClient;
import com.dahuatech.icc.oauth.http.IClient;
import com.dahuatech.icc.oauth.model.v202010.GeneralRequest;
import com.dahuatech.icc.oauth.model.v202010.GeneralResponse;
import com.huimv.common.utils.StringUtilsWork;
import com.huimv.video.dhicc.result.R;
import com.huimv.video.dhicc.util.GetResponse;
import net.sf.json.JSONObject;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;
import java.text.SimpleDateFormat;
import java.util.Calendar;
import java.util.Date;
import java.util.HashMap;
import java.util.Map;

//门禁是不一样的
@RestController
@RequestMapping("person")
public class ClientPersonManageController {


    //刷脸失败记录
    @RequestMapping("/getPersonOpenDoorFail")
    public R getAccidentRecord(@RequestBody Map<String, Object> params1 ) throws ClientException {
        Integer farmId= (int) params1.get("farmId");
        if(farmId!=1){
            //返回为空数据
            return  null;
        }
        SimpleDateFormat format = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
        Calendar c = Calendar.getInstance();
        Date date = new Date();
        c.setTime(date);
        c.set(Calendar.HOUR, 0);
        c.set(Calendar.MINUTE, 0);
        c.set(Calendar.SECOND, 0);
        Date A = c.getTime();
        String formatA = format.format(A);
        c.set(Calendar.HOUR, +24);
        Date d = c.getTime();
        String formatD = format.format(d);
        if (!StringUtilsWork.isNotEmpty( (String) params1.get("startSwingTime"))){
            params1.put("startSwingTime",formatA);
            params1.put("endSwingTime",formatD);
        }
        params1.put("containDomain","1");
        params1.put("openResult",0); //刷脸失败
        String URL = "/evo-apigw/evo-accesscontrol/1.0.0/card/accessControl/swingCardRecord/bycondition/combined?";  //获取事件URL    post请求
    IClient iClient = new DefaultClient();
    String timestamp = String.valueOf((new Date()).getTime());
    Long aLong = Long.valueOf(timestamp);
    String NewUrl = URL + aLong;
        System.out.println("开始执行");
    //这种已经在配置文件里面安排了账号ip以及密码
    GeneralRequest generalRequest = new GeneralRequest(NewUrl, Method.POST);
        System.out.println(NewUrl);
        generalRequest.header("Content-Type", " application/json");
        System.out.println(JSON.toJSONString(params1));
    //里面是
        generalRequest.body(JSON.toJSONString(params1));
    //发起请求处理应答
    GeneralResponse generalResponse = iClient.doAction(generalRequest, generalRequest.getResponseClass());
        System.out.println("执行结束");
    JSONObject jsonObject = JSONObject.fromObject(generalResponse.getResult());
        GetResponse getResponse = new GetResponse();

        return  R.ok("请求成功").put("data", jsonObject ).put("total",  getResponse.SendMassageGetPagePersonAlarm((String) params1.get("startSwingTime"),(String) params1.get("endSwingTime")));
}


    /*
         * @param params
         *   下面是前端提交的参数 直接让她写死了   这个是查不同部门的人的接口
         *{searchKey: "", pageNum: 1, pageSize: 10, departmentId: 4, isContain: true, statusList: [1, 2]}      维修部门
          {searchKey: "", pageNum: 1, pageSize: 10, departmentId: 2, isContain: true, statusList: [1, 2]}      技术部门
          {searchKey: "", pageNum: 1, pageSize: 10, departmentId: 5, isContain: true, statusList: [1, 2]}      基层部门
         * @return
         * @throws ClientException
         */
    @RequestMapping("/ge_person_list")
    public GeneralResponse ge_person_list ( @RequestBody Map<String, Object> params ) throws ClientException {
        Integer farmId= (int) params.get("farmId");
        if(farmId!=1){
            //返回为空数据
            return  null;
        }

        String URL = "/evo-apigw/evo-brm/1.2.0/person/page; "  ;  // 人员列表的接口
        IClient iClient = new DefaultClient();
        System.out.println("开始执行");
        GeneralRequest generalRequest = new GeneralRequest(URL, Method.POST);
        generalRequest.header("Content-Type", " application/json");
        System.out.println(JSON.toJSONString(params));
        //里面是
        generalRequest.body(JSON.toJSONString(params));
        //发起请求处理应答
        GeneralResponse generalResponse = iClient.doAction(generalRequest, generalRequest.getResponseClass());
        System.out.println("执行结束");
        return generalResponse;
    }

    /**
     * 人员通行记录 ---测试通过  ---参数说明见大华官网 https://open-icc.dahuatech.com/#/
     * 此处只做了代理
     *pageNum              	是	Integer	当前页
     * pageSize	            是	Integer	分页大小
     * startSwingTime	    否	String	查询开始时间
     * endSwingTime	        否	String	查询结束时间
     * openType          	否	Integer	开门类型
     * category	           否	String	卡片类型, null-全部, 0-IC卡, 1-有源RFID, 2-CPU卡
     * personName          	否	String	人员名称
     * personCode	        否	String	人员编号
     * channelCode	       否	String	通道编码
     * deptIds	           否	String	部门ID, 部门间”, “分隔
     * cardNumber       	否	String	卡号
     * enterOrExit       	否	String	事件类型, null-全部, 1-进门, 2出门, 3-进/出门
     * openResult	        否	Integer	开门结果, null-全部, 1-成功, 0-失败
     * @param params
     * @return
     * @throws ClientException
     */

    @RequestMapping("/get_person_record")
    public GeneralResponse getAccidentRecord1( @RequestBody Map<String, Object> params ) throws ClientException {

        Integer  farmId= (int) params.get("farmId");
        if(farmId!=1){
            //返回为空数据
            return  new GeneralResponse() ;
        }

        String URL = "/evo-apigw/evo-accesscontrol/1.0.0/card/accessControl/swingCardRecord/bycondition/combined";  //获取事件URL    post请求
        IClient iClient = new DefaultClient();
        System.out.println("开始执行");
        //这种已经在配置文件里面安排了账号ip以及密码
        GeneralRequest generalRequest = new GeneralRequest(URL, Method.POST);
        generalRequest.header("Content-Type", " application/json");
        System.out.println(JSON.toJSONString(params));
        //里面是
        generalRequest.body(JSON.toJSONString(params));
        //发起请求处理应答
        GeneralResponse generalResponse = iClient.doAction(generalRequest, generalRequest.getResponseClass());
        System.out.println("执行结束");
        return generalResponse;
    }



   //总页数
    @RequestMapping("/get_person_record_totalpage")
    public GeneralResponse get_person_record_totalpage( @RequestBody Map<String, Object> params ) throws ClientException {
        Integer  farmId= (int) params.get("farmId");
        if(farmId!=1){
            //返回为空数据
            return  new GeneralResponse() ;
        }
        String URL = "/evo-apigw/evo-accesscontrol/1.0.0/card/accessControl/swingCardRecord/bycondition/combinedCount?systime=";  //获取事件URL    post请求
        IClient iClient = new DefaultClient();
        String timestamp = String.valueOf((new Date()).getTime());
        Long aLong = Long.valueOf(timestamp);
        String NewUrl = URL + aLong;
        System.out.println("开始执行");
        //这种已经在配置文件里面安排了账号ip以及密码
        GeneralRequest generalRequest = new GeneralRequest(NewUrl, Method.POST);
        System.out.println(NewUrl);
        generalRequest.header("Content-Type", " application/json");
        System.out.println(JSON.toJSONString(params));
        //里面是
        generalRequest.body(JSON.toJSONString(params));
        //发起请求处理应答
        GeneralResponse generalResponse = iClient.doAction(generalRequest, generalRequest.getResponseClass());
        System.out.println("执行结束");
        return generalResponse;
    }






    @RequestMapping("/get_person_detail")
    public GeneralResponse getPersonDetail( @RequestBody Map<String, Object> params ) throws ClientException {

        Integer  farmId= (int) params.get("farmId");
        if(farmId!=1){
            //返回为空数据
            return  new GeneralResponse() ;
        }
        String URL = "/evo-apigw/evo-accesscontrol/${version}/card/accessControl/swingCardRecord/19241";  //获取事件URL    post请求
        IClient iClient = new DefaultClient();
        System.out.println("开始执行");
        String URL_id = URL + params.get("id");
        //这种已经在配置文件里面安排了账号ip以及密码
        GeneralRequest generalRequest = new GeneralRequest(URL_id, Method.POST);
        generalRequest.header("Content-Type", " application/json");
        //发起请求处理应答
        GeneralResponse generalResponse = iClient.doAction(generalRequest, generalRequest.getResponseClass());
        System.out.println("执行结束");
        return generalResponse;
    }

}
